leetcode中等91解码方法

Posted qq_40707462

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了leetcode中等91解码方法相关的知识,希望对你有一定的参考价值。

一条包含字母 A-Z 的消息通过以下映射进行了 编码 :

‘A’ -> “1”
‘B’ -> “2”

‘Z’ -> “26”
要 解码 已编码的消息,所有数字必须基于上述映射的方法,反向映射回字母(可能有多种方法)。例如,“11106” 可以映射为:

"AAJF" ,将消息分组为 (1 1 10 6)
"KJF" ,将消息分组为 (11 10 6)
注意,消息不能分组为  (1 11 06) ,因为 "06" 不能映射为 "F" ,这是由于 "6""06" 在映射中并不等价。

给你一个只含数字的 非空 字符串 s ,请计算并返回 解码 方法的 总数

题目数据保证答案肯定是一个 32 位 的整数。

示例 1:

输入:s = "12"
输出:2
解释:它可以解码为 "AB"1 2)或者 "L"12)。

示例 2:

输入:s = "226"
输出:3
解释:它可以解码为 "BZ" (2 26), "VF" (22 6), 或者 "BBF" (2 2 6)

示例 3:

输入:s = "0"
输出:0
解释:没有字符映射到以 0 开头的数字。
含有 0 的有效映射是 'J' -> "10"'T'-> "20" 。
由于没有字符,因此没有有效的方法对此进行解码,因为所有数字都需要映射。

思路1:dfs(超时)

class Solution 
    public int numDecodings(String s) 
        if (s.length() < 1 || s.charAt(0) == '0') return 0;
        return dfs(s, 0);
        
    
    public int dfs(String s,int depth)
        if(depth>=s.length()) return 1;
        int res=0;
        if(s.charAt(depth)!='0')//不管一位还是两位都不能以0开头
            res+=dfs(s,depth+1);
            if(depth+2<=s.length())
                int total = (s.charAt(depth)-'0')*10
                					+(s.charAt(depth+1)-'0');
                if (total <= 26) res += dfs(s, depth + 2);
            
        
        return res;
    

思路2:记忆化dfs

用一个数组保存当前下标的解法的数目

class Solution 
    int[]memory;
    public int numDecodings(String s) 
        memory=new int[s.length()];
        return dfs(s, 0);
        
    
    public int dfs(String s,int depth)
        if(depth>=s.length()) return 1;
        if(memory[depth]>0) return memory[depth];
        else if(memory[depth] <0) return 0;
        int res=0;
        if(s.charAt(depth)!='0')
            res+=dfs(s,depth+1);
            if(depth+2<=s.length())
                int total = (s.charAt(depth) - '0') * 10 + (s.charAt(depth+1) - '0');
                if (total <= 26) res += dfs(s, depth + 2);
            
        
        memory[depth]= res==0?-1:res;//遍历过的深度都存下来
        return res;
    

思路3:动态规划

爬楼梯问题f[i] = f[i-1] + f[i-2]的变种

  1. 对于每一个字符,首先判断能不能自己有对应字母,若有,dp[i] = dp[i-1];
  2. 再判断与i-1的元素相结合能不能有对应字母,若有,dp[i]+=dp[i-2];相当于把i-1和i的元素看成一个整体A(已经含有两个元素),若前i-2个元素有m种组合方式,那么再加上A,还是只有m种组合方式
class Solution 
    public int numDecodings(String s) 
        int[]dp=new int[s.length()];
        if(s.charAt(0)=='0') return 0;
        dp[0]=1;
        for(int i=1;i<s.length();i++)
            if(s.charAt(i)>='1'&&s.charAt(i)<='9') dp[i]=dp[i-1];
            if(s.charAt(i-1)=='1'||
            			(s.charAt(i-1)=='2'&&s.charAt(i)<='6'))
                if(i>=2) dp[i]+=dp[i-2];
                else dp[i]++;
            
        
        return dp[s.length()-1];
    

以上是关于leetcode中等91解码方法的主要内容,如果未能解决你的问题,请参考以下文章

Leetcode 91 解码方法

LeetCode#91-解码方法

LeetCode 91. 解码方法

LeetCode 91 动态规划 Decode Ways 解码方法

leetcode 91. 解码方法

leetcode 91. 解码方法